## ace-dt bottle sign

Signs a bottle manifest digest with a private key, writing the signature to the .signature directory within the bottle directory.

### Synopsis

Description:
  Signs the bottle's manifest digest using a unique user-defined alias name for a private key whose metadata
  is outlined in the ace-dt config file. This metadata is signed alongside the manifest digest
  and is used during verification to locate the public key associated with the signing private key.

  The signature layer, manifest, and config are written to the .signature directory within
  the bottle directory. The layer is named by its digest. The manifest is named by the hash
  algorithm used, the manifest digest itself, with a .sig suffix. There is a single signature
  manifest for all signatures, each consisting of a layer, of the same manifest digest.

  It is possible to directly sign a bottle manifest digest without adding private key metadata
  to ace-dt config. This use case requires using all --key-path, --key-api, --key-id, and
  --user-id flags. Supported key management system apis include gitlab.

  Current supported api's include no-kms and gitlab.

  Signing a bottle with altered data or metadata will automatically deprecate 
  the previous version (bottleID) of this bottle. This can be disabled 
  by passing the --no-deprecate flag.


```
ace-dt bottle sign PRIVATE_KEY_ALIAS [flags]
```

### Examples

```

To sign a manifest digest with alias 'MyPrivateKey':
	ace-dt bottle sign MyPrivateKey

To sign a manifest digest by directly providing private key metadata:
	ace-dt bottle sign --key-path PATH/TO/PRIVATE.KEY --key-api KMS_API --key-id KEY_TITLE --user-id KEY_OWNER_ID

```

### Options

```
  -h, --help              help for sign
      --key-api string    The API added to the signed annotations, which is used during verification to locate the corresponding public key. Current api's supported are no-kms and gitlab.
      --key-id string     The title/ID of the signing key.
      --key-path string   Path to a PEM formatted private key.
      --no-deprecate      Disable deprecation of previous bottle version
      --user-id string    The key owner's identity, typically a username for the KeyAPI.
```

### Options inherited from parent commands

```
  -d, --bottle-dir string          Specify bottle directory (default "/builds/ace/data/tool")
      --config stringArray         configuration file location (setable with env "ACE_DT_CONFIG").
                                   The first configuration file present is used.  Others are ignored.
                                    (default [ace-dt-config.yaml,HOMEDIR/.config/ace/dt/config.yaml,/etc/ace/dt/config.yaml])
  -v, --verbosity strings[=warn]   Logging verbosity level (also setable with environment variable ACE_DT_VERBOSITY)
                                   Aliases: error=0, warn=4, info=8, debug=12 (default [error])
```

### SEE ALSO

* [ace-dt bottle](ace-dt_bottle.md)	 - A command group for common data bottle operations

